$Invisiblity::Min = 2; //Invisiblity Min Speed
$Invisiblity::Max = 4; //Invisiblity Max Speed

//Invisibility Global Silent Loop
function InvisibilityGlobalSilentLoop(%player)
{
	if(!$Pref::Invisibility::On) //if Pref: Invisibility disabled
		return; //stop here
	for(%i=0;%i<ClientGroup.getCount();%i++) //search through all clients
	{
		%client = ClientGroup.getObject(%i); //individual client, number i
		if(!isObject(%player = %client.player) || %player.getState() $= "Dead" || !isObject(%player.client)) //if player DNE, or player is dead, or player's client DNE
			continue; //skip player, and continue looping
		InvisibilityStateCheck(%player); //check invisibility
		%isInvisibilityer = true; //since at least one player was Invisibility-ready
	}

	if(%isInvisibilityer) //if an Invisibilityr exists
	{
		cancel($Invisibility::SilentLoop); //cancel any pending Silent Loop schedules
		$Invisibility::SilentLoop = scheduleNoQuota(1,0,InvisibilityGlobalSilentLoop); //continue the loop
	}
}

//Invisibility Check
function InvisibilityStateCheck(%player)
{
	%vel = %player.getVelocity(); //player velocity
	if((%lastVel = %player.InvisibilityLastVel) !$= "")
	{
		%vDot = vectorDot(%vel,%lastVel);
		if((%lastVDot = %player.InvisibilityLastVDot) !$= "")
		{
			%ROC = mAbs(%vDot-%lastVDot);
			if(%vDot > 0 && %ROC == 0)
				%player.InvisibilityIntentMag++;
			else
				%player.InvisibilityIntentMag = 0;
		}
		%player.InvisibilityLastVDot = %vDot;
		
		%intentMag = %player.InvisibilityIntentMag;
	//	bottomprint(%player.client,"\c5Intent. Magnitude = \c3" SPC %intentMag);
	}
	%player.InvisibilityLastVel = %vel; //store last vel to player object
	%mag = vectorLen(%vel); //magnitude of player velocity
	if(%mag <= 1)
		%player.InvisibilityIntentMag = 0;
	%inRange = (%mag > $Invisiblity::Min && %mag < $Invisiblity::Max);
//	if(%inRange)
//	centerprint(%player.client,"\c5General Magnitude = \c3" SPC %mag);
	if(%inRange && !isObject(%player.tool[%player.currTool]) && !%player.invisibilityOverride && %intentMag > 100) //if moving, inconspicuously (no camping!), and item unequiped, and not recently camped out, and intentional magnitude greater than 100
	{
		if(!%player.invisibilityActive)
		{
		//	talk("Go Invisible, Spiritually.");
			%player.hideNode("ALL"); //hide entire person
			%player.invisibilityActive = true;
			if(%player.invisibilityDisabled)
				%player.invisibilityDisabled = false;
		}
	}
	else //otherwise
	{
		if(!%player.invisibilityDisabled)
		{
		//	talk("Go Visible, conspicuously.");
			%player.unhideNode("ALL"); //unhide head, specifically (bug fix, nonredundant)
			%player.client.applyBodyParts(); //restore visibility
			%player.invisibilityDisabled = true;
			if(%player.invisibilityActive)
				%player.invisibilityActive = false;
		}
	}
	if(%mag < 1 || %mag > 4) //if standing still (essentially), or moving conspicuously
	{
		%player.invisibilityOverride = true;
		cancel(%player.inviOverrideSched); 
		%player.inviOverrideSched = schedule(400,0,eval,%player @ ".invisibilityOverride = false;");
	}
}

package SpiritualInvisibility
{
	//on Datablock Change
	function Armor::onNewDatablock(%data,%player)
	{
		Parent::onNewDatablock(%data,%player); //Parent default fcn
		if(isObject(%player.client)) //if client exists (i.e. Real Player Character)
			schedule(1,0,InvisibilityGlobalSilentLoop); //start the Global Silent Loop
	}
};activatePackage(SpiritualInvisibility);